Blob


1 #!/bin/sh
2 #
3 # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 #
5 # Permission to use, copy, modify, and distribute this software for any
6 # purpose with or without fee is hereby granted, provided that the above
7 # copyright notice and this permission notice appear in all copies.
8 #
9 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17 name=$(getent passwd $USER | cut -d: -f5)
18 export GOT_AUTHOR="$name <$(whoami)@$(hostname)>"
20 export MALLOC_OPTIONS=S
22 function git_init
23 {
24 git init -q "$@"
25 }
27 function git_commit
28 {
29 local repo="$1"
30 shift
31 (cd $repo && git commit -q -a "$@")
32 }
34 function git_rm
35 {
36 local repo="$1"
37 shift
38 (cd $repo && git rm -q "$@")
39 }
41 function git_show_head
42 {
43 local repo="$1"
44 (cd $repo && git show --no-patch --pretty='format:%H')
45 }
47 function git_show_parent_commit
48 {
49 local repo="$1"
50 (cd $repo && git show --no-patch --pretty='format:%P')
51 }
53 function git_show_tree
54 {
55 local repo="$1"
56 (cd $repo && git show --no-patch --pretty='format:%T')
57 }
59 function trim_obj_id
60 {
61 let trimcount=$1
62 id=$2
64 pat=""
65 while [ trimcount -gt 0 ]; do
66 pat="[0-9a-f]$pat"
67 let trimcount--
68 done
70 echo ${id%$pat}
71 }
73 function git_commit_tree
74 {
75 local repo="$1"
76 local msg="$2"
77 local tree="$3"
78 (cd $repo && git commit-tree -m "$msg" "$tree")
79 }
81 function make_test_tree
82 {
83 repo="$1"
85 echo alpha > $repo/alpha
86 echo beta > $repo/beta
87 mkdir $repo/gamma
88 echo delta > $repo/gamma/delta
89 mkdir $repo/epsilon
90 echo zeta > $repo/epsilon/zeta
91 }
93 function get_blob_id
94 {
95 repo="$1"
96 tree_path="$2"
97 filename="$3"
99 got tree -r $repo -i $tree_path | grep ${filename}$ | cut -d' ' -f 1
102 function test_init
104 local testname="$1"
105 local no_tree="$2"
106 if [ -z "$testname" ]; then
107 echo "No test name provided" >&2
108 return 1
109 fi
110 local testroot=`mktemp -p /tmp -d got-test-$testname-XXXXXXXX`
111 mkdir $testroot/repo
112 git_init $testroot/repo
113 if [ -z "$no_tree" ]; then
114 make_test_tree $testroot/repo
115 (cd $repo && git add .)
116 git_commit $testroot/repo -m "adding the test tree"
117 fi
118 echo "$testroot"
121 function test_cleanup
123 local testroot="$1"
125 (cd $testroot/repo && git fsck --strict \
126 > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
127 ret="$?"
128 if [ "$ret" != "0" ]; then
129 echo -n "git fsck: "
130 cat $testroot/fsck.stderr
131 echo "git fsck failed; leaving test data in $testroot"
132 return 1
133 fi
135 rm -rf "$testroot"
138 function run_test
140 testfunc="$1"
141 echo -n "$testfunc "
142 $testfunc
145 function test_done
147 local testroot="$1"
148 local result="$2"
149 if [ "$result" == "0" ]; then
150 test_cleanup "$testroot" || return 1
151 echo "ok"
152 elif echo "$result" | grep -q "^xfail"; then
153 # expected test failure; test reproduces an unfixed bug
154 echo "$result"
155 test_cleanup "$testroot" || return 1
156 else
157 echo "test failed; leaving test data in $testroot"
158 fi